/*
  step_motor6.h
  Cree par Silicium628, 9 nov 2014
  code free Open source
*/

#ifndef STEP_MOTOR6_H
#define STEP_MOTOR6_H


// ces ports doivent correspondre à la configuration matérielle. On peut les changer ici.
#define PORT_moteur_enable	PORTC
#define PORT_fin_de _course	PORTK
#define PORT_step			PORTL
#define PORT_dir			PORTL

#define PORT_led_blanche 	PORTC
#define bit_LED_blanche 	0b01000000;

class Step_Motor 
{
 private :
 	
	uint8_t sens;
	uint8_t marche; // peut prendre les valeurs 0 et 1 mais aussi d'autres valeurs >1 correspondants à des modes de fonctionnement divers.
	long compteur_impuls; //32 bits (4 bytes) ; compte les impulsions recues. est incrémenté automatiquement. ne fait qu'augmenter qq soit le sens de rotation.
	
	
 public:
	Step_Motor();

	uint8_t bit_ENABLE;
	uint8_t bit_finCourse1;
	uint8_t bit_finCourse2;
	uint8_t bit_STEP;
	uint8_t bit_DIR;
	
	uint16_t steps_par_tour;
	uint8_t tours_par_mm;
	uint8_t impuls_par_step;
	uint16_t steps_par_mm;
	uint16_t impuls_par_mm;

    uint8_t stop_sens1; // (fin de course)
    uint8_t stop_sens2; // (fin de course)	
	
	long position_impuls; //32 bits (4 bytes) ; nombre d'impulsions; automatiquement incrémenté ou décrémenté par la rotation
	
	void init();
	void enable();
	void disable();
	void RAZ_pos();
	int32_t get_compteur_impuls();
	void RAZ_compteur_impuls();
	void step();	
    void set_sens(uint8_t valeur); // valeur = 0 ou 1.
    void set_marche(uint8_t valeur); // valeur = 0 ou 1. (1 -> mise en marche si l'état du stop_sens le permet. 0 -> arret du moteur)
    uint8_t get_marche();
    uint8_t get_sens();
    void set_stop_sens1(uint8_t valeur); // valeur = 0 ou 1. (1->signifie arret du moteur, 0 -> remise en marche possible)
	void set_stop_sens2(uint8_t valeur);
};


#endif
